import numpy as np


def Phi_BAD(u, param):
    N = np.size(u)
    x0 = param['x0']
    q = param['q']
    h = param['T']/N

    # forward sweep
    x = np.zeros(N+1)
    x[0] = x0
    for i in range(N):
        x[i+1] = x[i] + h*((1 - x[i])*x[i] + u[i])

    f = q * x[N]**2

    # Backward AD. only one output, so we only need to seed once
    ubar = np.zeros(N)
    xbar = np.zeros(N+1)
    fbar = 1  # this is our seed vector

    # recursively obtain bar quantities
    xbar[N] = xbar[N] + 2*q*x[N]*fbar
    for i in reversed(range(N)):
        df_dx = 1 + h*(1 - 2*x[i])
        xbar[i] = xbar[i] + xbar[i+1]*df_dx
        df_du = h
        ubar[i] = ubar[i] + xbar[i+1]*df_du

    return (f, ubar[np.newaxis, :])
